;Example #1
#include <GUICtrlSetOnHover_UDF.au3>

GuiCreate("GUICtrlSetOnHover DEMO #1", 280, 200)

$Button = GUICtrlCreateButton("Button", 20, 40)
GUICtrlSetOnHover($Button, "On_Hover_Func", "On_Leave_Hover_Func")

$Label = GUICtrlCreateLabel("Label", 200, 40)
GUICtrlSetOnHover($Label, "On_Hover_Func", "On_Leave_Hover_Func")

$CheckBox = GUICtrlCreateCheckbox("CheckBox", 20, 120)
GUICtrlSetOnHover($CheckBox, "On_Hover_Func", "On_Leave_Hover_Func")

$Edit = GUICtrlCreateEdit("Edit", 200, 120)
GUICtrlSetOnHover($Edit, "On_Hover_Func", "On_Leave_Hover_Func")

GUISetState()

While 1
	$Msg = GUIGetMsg()
	Switch $Msg
		Case -3
			GUIDelete()
			ExitLoop
	EndSwitch
WEnd

Func On_Hover_Func($CtrlID)
	Printf("Control " & $CtrlID & " [Data: " & GUICtrlRead($CtrlID, 1) & "] Is Now Hovered")
EndFunc

Func On_Leave_Hover_Func($CtrlID)
	Printf("Control " & $CtrlID & " [Data: " & GUICtrlRead($CtrlID, 1) & "] Is Now NOT Hovered")
EndFunc

Func Printf($Str, $Line=@ScriptLineNumber)
	ConsoleWrite("!===========================================================" & @LF & _
				"+======================================================" & @LF & _
				"--> Script Line (" & $Line & "):" & @LF & "!" & @TAB & $Str & @LF & _
				"+======================================================" & @LF)
EndFunc


;Example #2

#include <GUICtrlSetOnHover_UDF.au3>

GuiCreate("GUICtrlSetOnHover DEMO #2", 280, 200)

$Button = GUICtrlCreateButton("Button", 20, 40, 100, 20)
GUICtrlSetOnHover(-1, "Hover_Func", "Leave_Hover_Func")

$Label = GUICtrlCreateLabel("Label", 200, 40, 100)
GUICtrlSetOnHover($Label, "Hover_Func", "Leave_Hover_Func")

$CheckBox = GUICtrlCreateCheckbox("CheckBox", 20, 120)
GUICtrlSetOnHover($CheckBox, "Hover_Func", "Leave_Hover_Func")

$Edit = GUICtrlCreateEdit("Edit", 150, 120, 100, 50)
GUICtrlSetOnHover($Edit, "Hover_Func", "Leave_Hover_Func")

GUISetState()

While 1
	$Msg = GUIGetMsg()
	Switch $Msg
		Case -3
			Exit
	EndSwitch
WEnd

Func Hover_Func($CtrlID)
	Switch $CtrlID
		Case $Button
			If GUICtrlRead($CtrlID) <> "New Button" Then GUICtrlSetData($CtrlID, "New Button")
		Case $Label
			GUICtrlSetColor($CtrlID, 0x00000FF)
			GUICtrlSetFont($CtrlID, Default, Default, 4)
		Case $CheckBox
			GUICtrlSetState($CtrlID, 1)
		Case $Edit
			If GUICtrlRead($CtrlID) <> "New Edit Data" Then GUICtrlSetData($CtrlID, "New Edit Data")
	EndSwitch
EndFunc

Func Leave_Hover_Func($CtrlID)
	Switch $CtrlID
		Case $Button
			If GUICtrlRead($CtrlID) <> "Button" Then GUICtrlSetData($CtrlID, "Button")
		Case $Label
			GUICtrlSetColor($CtrlID, 0x0)
			GUICtrlSetFont($CtrlID, Default, Default, 0)
		Case $CheckBox
			GUICtrlSetState($CtrlID, 4)
		Case $Edit
			If GUICtrlRead($CtrlID) <> "Edit" Then GUICtrlSetData($CtrlID, "Edit")
	EndSwitch
EndFunc
